# buffer.rb
# This is NOT the first definition of Buffer.

class Buffer
  DEFAULT_VALUES = Hash.new
  
  def to_s
    '<Buffer "' + name + '">'
  end
  
  def inspect
    '<Buffer "' + name + '">'
  end
  
  def Buffer.add_attr(name, default = nil)
    if name.is_a? Fixnum
      name = name.id2name
    elsif not name.is_a? String
      msg = sprintf("wrong argument type %s (expected String or ID)",
		    name.type)
      raise TypeError, msg
    end
    DEFAULT_VALUES[name] = default
    eval %{
      def #{name}
	if defined? @#{name}
	  @#{name}
	else
	  begin
	    @#{name} = DEFAULT_VALUES['#{name}'].clone
	  rescue
	    @#{name} = DEFAULT_VALUES['#{name}']
	  end  
	end
      end
      
      def #{name}=(obj)
	@#{name} = obj
      end
    }
  end
  
  def Buffer.del_attr(var)
    if var.is_a? String
      name = var
    elsif var.is_a? Fixnum
      name = var.id2name
    else
      msg = sprintf("wrong argument type %s (expected String or ID)",
		    name.type)
      raise TypeError, msg
    end
    if DEFAULT_VALUES.has_key? name
      DEFAULT_VALUES.delete name
      eval "undef #{name}"
      eval "undef #{name}="
    else
      msg = sprintf("no such attr `%s'", name)
      raise Exception, msg
    end
  end
  
  def Buffer.set_default(var, default)
    if var.instance_of? String
      name = var
    elsif var.instance_of? Fixnum
      name = var.id2name
    else
      msg = sprintf("wrong argument type %s (expected String or ID)",
		    name.type)
      raise TypeError, msg
    end
    if name == "tab"
      $tab_default = default
    else
      if DEFAULT_VALUES.has_key? name
	DEFAULT_VALUES[name] = default
      else
	msg = sprintf("no such attr `%s'", name)
	raise Exception, msg
      end
    end
  end
end
