# jed-misc.rb

def messagef(*args)
  message sprintf(*args)
end

def insertf(*args)
  insert sprintf(*args)
end

def save_excursion
  push_spot
  begin
    yield
  ensure
    pop_spot
  end
end

def eval_region
  message eval(buffer_substring, TOPLEVEL_BINDING).inspect
end

def eval_buffer
  save_excursion do
    beginning_of_buffer
    push_mark
    end_of_buffer
    message eval(buffer_substring, TOPLEVEL_BINDING).inspect
  end
end

def bol_fsearch(str)
  beginning_of_line
  search_forward str
end

def bol_bsearch(str)
  beginning_of_line
  search_backward str
end

def bol_skip_white
  beginning_of_line
  skip_whitespace
end

def bol_trim
  beginning_of_line
  trim_whitespace
end

def get_pos
  return what_line, what_column
end

def set_pos(line, column)
  goto_line line
  goto_column column
end

def skip_whitespace_backward
  skip_chars_backward(" \t\r\n")
end

def looking_at_backward(str)
  n = str.length
  save_excursion do
    if n != backward_char(n)
      return FALSE
    else
      return looking_at(str);
    end
  end
end

def looking_at_words(*words)
  words.each do |word|
    return TRUE if looking_at(word)
  end
  return FALSE
end

def define_keywords(name, tblnum, *words)
  keywords = words.sort { |a, b|
    a.length <=> b.length
  }
  
  len = 0
  group = []
  while word = keywords.delete_at(0)
    if word.length != len
      if group.length > 0
	define_keywords_n(name, group.sort.join, len, tblnum)
	group.clear
      end
      len = word.length
    end
    group.push(word)
  end
  if group.length > 0
    define_keywords_n(name, group.sort.join, len, tblnum)
  end
end
