/* rwindow.c
   Copyright (C) 1997 MAEDA Shugo

   module WindowFunctions */

#include "config.h"
#include "jed-feat.h"
#include "window.h"
#include "jruby.h"

VALUE mWinFunc;

static VALUE winfunc_other_window(VALUE obj)
{
    return RBOOL(other_window());
}

static VALUE winfunc_split_window(VALUE obj)
{
    return RBOOL(split_window());
}

static VALUE winfunc_one_window(VALUE obj)
{
    return RBOOL(one_window());
}

static VALUE winfunc_enlarge_window(VALUE obj)
{
    return RBOOL(enlarge_window());
}

static VALUE winfunc_delete_window(VALUE obj)
{
    return RBOOL(delete_window());
}

static VALUE winfunc_window_line(VALUE obj)
{
    return INT2FIX(window_line());
}

static VALUE winfunc_count_windows(VALUE obj)
{
    return INT2FIX(num_windows());
}

void Init_rb_window()
{
    mWinFunc = rb_define_module("WindowFunctions");
    rb_define_module_function(mWinFunc, "other_window",
			      winfunc_other_window, 0);
    rb_define_module_function(mWinFunc, "split_window",
			      winfunc_split_window, 0);
    rb_define_module_function(mWinFunc, "delete_other_windows",
			      winfunc_one_window, 0);
    rb_define_module_function(mWinFunc, "enlarge_window",
			      winfunc_enlarge_window, 0);
    rb_define_module_function(mWinFunc, "delete_window",
			      winfunc_delete_window, 0);
    rb_define_module_function(mWinFunc, "window_line",
			      winfunc_window_line, 0);
    rb_define_module_function(mWinFunc, "count_windows",
			      winfunc_count_windows, 0);
    rb_include_module(rb_cObject, mWinFunc);
}
